"use strict";
var Placeholder = (function () {
    function Placeholder(methodName) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        this.methodName = methodName;
        this.children = [];
        this.args = args;
    }
    Placeholder.prototype.replaceWith = function (parent) {
        this.source = this.methodName === undefined ? parent : parent[this.methodName].apply(parent, this.args);
        for (var _i = 0, _a = this.children; _i < _a.length; _i++) {
            var c = _a[_i];
            c.replaceWith(this.source);
        }
        this.children = undefined;
    };
    return Placeholder;
}());
exports.Placeholder = Placeholder;
function definePlaceholderMethod(methodName) {
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i - 0] = arguments[_i];
        }
        if (this.source !== undefined) {
            return (_a = this.source)[methodName].apply(_a, args);
        }
        else {
            var p = new (Placeholder.bind.apply(Placeholder, [void 0, methodName].concat(args)))();
            this.children.push(p);
            return p;
        }
        var _a;
    };
}
var methods = [
    "map", "mapTo", "subscribe",
    "combine", "filter", "filterApply", "scanS",
    "ap", "lift", "chain", "push", "addListener", "pull", "beginPulling", "endPulling", "observe", "at", "flatten" // behavior
];
for (var _i = 0, methods_1 = methods; _i < methods_1.length; _i++) {
    var name = methods_1[_i];
    Placeholder.prototype[name] = definePlaceholderMethod(name);
}
function placeholder() {
    return new Placeholder();
}
exports.placeholder = placeholder;
//# sourceMappingURL=placeholder.js.map